#ifndef _DXC9000_H_
#define _DXC9000_H_

#define DXC9000_OFF           0
#define DXC9000_ON            1

#define DXC9000_CTEMP_3200K   0
#define DXC9000_CTEMP_5600K   1
#define DXC9000_CTEMP_AUTO    2

#define DXC9000_SCAN_FS       0
#define DXC9000_SCAN_NORMAL   1
#define DXC9000_SCAN_VGA      2

#define DXC9000_IRISMODE_AUTO 0
#define DXC9000_IRISMODE_FIX  1

#define DXC9000_GAIN_AGC      0
#define DXC9000_GAIN_STEP     1

#define DXC9000_SHUTTER_STEP     0
#define DXC9000_SHUTTER_VARIABLE 1
#define DXC9000_SHUTTER_CCDIRIS  2
#define DXC9000_SHUTTER_OFF      3

#define DXC9000_WHITEBALLANCE_ATW    0
#define DXC9000_WHITEBALLANCE_AWB    1
#define DXC9000_WHITEBALLANCE_MANUAL 2

#define DXC9000_EXTCTRL_GENLOCK 0
#define DXC9000_EXTCTRL_TRIGIN  1

typedef struct{
  int zoom, focus, iris, gainstep, detaillevel;
  int scanmode, whiteballance, rgain, bgain, shutter, shutterspeed;
  int hphase, scphasefine, colorbars;
  unsigned char D1, D2, D3;
} DXC9000;
DXC9000 Camera;

extern char *shutterString[];
extern char *commandString[];

#define COMMANDNUM 29 /* CommandType󷿤ο */
typedef enum{
    ZOOM,
    FOCUS,
    IRISMODE,
    IRIS,
    CTEMP,
    GAMMA,
    GAIN,
    GAINSTEP,
    DETAIL,
    DETAILLEVEL,
    SHUTTER,
    SHUTTERSPEED,
    WHITEBALLANCE,
    RGAIN,
    BGAIN,
    SCANMODE,
    EXTCTRL,
    HPHASE,
    SCPHASEROUGH,
    SCPHASEFINE,
    GSYNC,
    DSUBVIDEO,
    FREEZE,
    AEDETECTION,
    EXTTRIGGER,
    FREEZEMODE,
    PROTECT,
    TRIGPULSE,
    COLORBARS } CommandType;

/* ץȥ */
void Dxc9000SendCommand(int aux, char *command);
void Dxc9000State(int aux, int D, unsigned char value, unsigned char mask);
void Dxc9000SetUp(int aux);
void Dxc9000Zoom(int aux,int value);
void Dxc9000Focus(int aux,int value);
void Dxc9000Iris(int aux,int value);
void Dxc9000ColorTemperture(int aux,int value);
void Dxc9000Gamma(int aux, int value);
void Dxc9000IrisMode(int aux, int value);
void Dxc9000Gain(int aux, int value);
void Dxc9000GainStep(int aux, int value);
void Dxc9000Detail(int aux, int value);
void Dxc9000DetailLevel(int aux, int value);
void Dxc9000Shutter(int aux, int value);
void Dxc9000ShutterSpeed(int aux, int value);
void Dxc9000WhiteBallance(int aux, int value);
void Dxc9000RGain(int aux, int value);
void Dxc9000BGain(int aux, int value);
void Dxc9000ScanMode(int aux, int value);
void Dxc9000SetColorBars(int aux, int value);
void Dxc9000ExtCtrl(int aux,int value);
void Dxc9000HPhase(int aux,int value);
void Dxc9000SCPhaseRough(int aux,int value);
void Dxc9000SCPhaseFine(int aux,int value);
void Dxc9000ColorBars(int aux,int value);

#endif

