/* ======================================================== */
/*  RS-232C $B$K$h$kDL?.(B                                      */
/* ======================================================== */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <termios.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#include "serial.h"

/*--< RS-232C $B%]!<%H$N=i4|2=(B >--*/
int SerialOpen(char *device,int baudrate){
  int p;
  struct termios targ;

  if ((p = open(device, O_RDWR, 0644)) < 0){
    fprintf(stderr,"ERROR: Cannot open %s.\n",device);
    exit(1);
  }
  tcgetattr(p, &targ);

  /* 
  BAUDRATE: $B%\!<%l!<%H$N@_Dj!%(Bcfsetispeed $B$H(B cfsetospeed $B$b;HMQ$G$-$k!%(B
  CRTSCTS : $B=PNO$N%O!<%I%&%'%"%U%m!<@)8f(B ($BI,MW$J7k@~$,A4$F$5$l$F$$$k%1!<(B
            $B%V%k$r;H$&>l9g$N$_!%(BSerial-HOWTO $B$N(B7$B>O$r;2>H$N$3$H(B)
  CS8     : 8n1 (8 $B%S%C%H!$%N%s%Q%j%F%#!$%9%H%C%W%S%C%H(B 1)
  CLOCAL  : $B%m!<%+%k@\B3!$%b%G%`@)8f$J$7(B
  CREAD   : $B<u?.J8;z(B(receiving characters)$B$rM-8z$K$9$k!%(B
  */

  //  targ.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
  targ.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
 
  /*
  IGNPAR  : $B%Q%j%F%#%(%i!<$N%G!<%?$OL5;k$9$k(B
  ICRNL   : CR $B$r(B NL $B$KBP1~$5$;$k(B($B$3$l$r9T$o$J$$$H!$B>$N%3%s%T%e!<%?$G(B 
            CR $B$rF~NO$7$F$b!$F~NO$,=*$j$K$J$i$J$$(B)
  $B$=$l0J30$N@_Dj$G$O!$%G%P%$%9$O(B raw $B%b!<%I$G$"$k(B($BB>$NF~NO=hM}$O9T$o$J$$(B)
  */
  targ.c_iflag = IGNPAR | ICRNL;
 
  /* Raw $B%b!<%I$G$N=PNO(B */
  targ.c_oflag = 0;
 
  /*
  ICANON  : $B%+%N%K%+%kF~NO$rM-8z$K$9$k(B
  $BA4$F$N%(%3!<$rL58z$K$7!$%W%m%0%i%`$KBP$7$F%7%0%J%k$OAw$i$;$J$$(B
  */
  targ.c_lflag = ICANON;
 
  tcflush(p, TCIFLUSH);
  tcsetattr(p, TCSANOW, &targ);
  return p;
}

unsigned char SerialGetc(int p){
  unsigned char c;
  int rc;
  do {
    rc = read(p ,&c,1);
  } while( rc <= 0);
  return c;
}

void SerialPutc(int p, char d){
  if (write(p, &d, 1) != 1) {
    fprintf(stderr,"Write Error in SerialPutc()\n");
    SerialClose(p);
    exit(1);
  }
  fsync(p);
}

void SerialClose(int p){
  close(p);
}

void SerialPutString(int p, char *s){
  if (write(p, s, strlen(s)) != strlen(s)) {
    fprintf(stderr,"Write Error in SerialPutString()\n");
    SerialClose(p);
    exit(1);
  }
  fsync(p);
}

void SerialGetString(int p, char *s, int n){
  if (read(p, s, n) != n) {
    fprintf(stderr,"Read Error in SerialGetString()\n");
    //    SerialClose(p);
    //    exit(1);
  }
}
